%global namedreltag -FCS
%global namedversion %{version}%{?namedreltag}
%define specversion %(echo %version | cut -d. -f1-2)
Name:          mojarra
Version:       2.1.2
Release:       %mkrel 2
Summary:       JavaServer(TM) Faces Implementation
Group:         Development/Java
License:       CDD, GPL
Url:           http://java.net/projects/mojarra/
# http://java.net/projects/javaserverfaces/

#svn export https://svn.java.net/svn/mojarra~svn/tags/2.1.2/ mojarra-2.1.2
#tar czf mojarra-2.1.2-src-svn.tar.gz mojarra-2.1.2

Source0:       http://java.net/projects/javaserverfaces/downloads/download/release/mojarra-%{namedversion}-source.zip
Source1:       mojarra-%{version}-02-build.xml
Source2:       mojarra-%{version}-01-jsf-impl-auto-generated-files.tar.gz
Patch0:        mojarra-2.1.2-jsf-pom-template.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: ant
BuildRequires: ant-contrib
BuildRequires: apache-commons-beanutils
BuildRequires: apache-commons-collections
BuildRequires: apache-commons-digester
BuildRequires: apache-commons-logging
BuildRequires: apache-portlet-1.0-api
BuildRequires: aqute-bndlib
BuildRequires: geronimo-servlet-3_0-api
BuildRequires: glassfish-el
BuildRequires: glassfish-jstl
BuildRequires: groovy
BuildRequires: hibernate-validation-api
BuildRequires: jbossweb
BuildRequires: junit4
BuildRequires: tomcat6-jsp-2.1-api
BuildRequires: tomcat6-lib
BuildRequires: tomcat6-servlet-2.5-api

#BuildRequires: glassfish
#   + appserv-rt.jar

BuildRequires: jetty >= 6.1.26-10
#   + jetty.jar
#   + jetty.annotations.jar
#   + jetty.plus.jar
#   + jetty/servlet-api/3.0.20100224/servlet-api-3.0.20100224.jar
#   + jetty.util.jar

BuildRequires: tlddoc
BuildRequires: yuicompressor

Requires:      java
Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
BuildArch:     noarch

%description
JavaServer Faces 2.1 (JSF) is a Java-based Web application framework intended
to simplify development integration of web-based user interfaces.
.
JSF hides complexity to maximize developer productivity and provides a
component model, page templating, Ajax support, client device independence,
clean separation of roles, better MVC handling for webapps, and world-class
IDE integration from every available Java IDE.
.
JSF also provides a easy integration with popular enterprise technologies,
including Hibernate, Spring, Seam, Jasper Reports and others. JSF 2.1 is
compatible with JavaEE 5 application servers or any server implementing
Servlet 2.5.

%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n mojarra-%{namedversion}-source
# -D -T
#:<< __GIL
for j in $(find -name "*.jar"); do
  mv $j  $j.no
done

%patch0 -p1

# TODO
# lib/cactus-1.7.1-javaee5.jar

# lib/javax.servlet.jar
# common/lib/maven-ant-tasks-2.0.10.jar.
# common/lib/sfx4j-1.0.jar
# common/lib/ant-contrib.jar
# common/lib/bnd-0.0.249.jar
# common/lib/installer-builder.jar

for j in $(find -name "*.class"); do
  rm -rf $j
done

mkdir -p together/{api,impl,tools,deps,injectionprovider}/{src,build/classes}

cp -R jsf-api/src/* together/api/src
cp -R jsf-api/build/generate/* together/api/src/
cp -R jsf-api/doc together/api/

cp -R jsf-ri/src/* together/impl/src
cp -R jsf-ri/build/generate/* together/impl/src/
cp -R jsf-ri/resources together/impl/
cp -R jsf-ri/conf together/impl/

cp -R jsf-tools/src/* together/tools/src
cp -R jsf-tools/conf together/tools/

mkdir -p together/build
cp -R jsf-tools/conf/* together/build/

cp -R injectionprovider/src/* together/injectionprovider/src

# TODO https://jsf-extensions.dev.java.net/ circular deps 
mv lib/jsf-extensions-test-time.jar.no lib/jsf-extensions-test-time.jar
imploverlay=`pwd`/lib/jsf-extensions-test-time.jar

pushd together

cp -p %{SOURCE1} ./build.xml

  sed -i "s|@DEP-PATH@|$deppath|g;" build.xml
  sed -i "s|@BASE-DIR@|`pwd`|g;" build.xml
  sed -i "s|@IMPL-OVERLAY@|$imploverlay|g;" build.xml
  sed -i "s|@MF-SPEC-TITLE@|JavaServer Faces|g;" build.xml
  sed -i "s|@MF-SPEC-VERSION@|%{specversion}|g;" build.xml
  sed -i "s|@MF-IMPL-TITLE@|Mojarra|g;" build.xml
  sed -i "s|@MF-IMPL-VERSION@|%{namedversion}|g;" build.xml

(
  cd impl/build/classes
  tar -xf %{SOURCE2}
)

# These injection providers are too much trouble to build (and not useful to JBoss)
# require glassfish-javaee jars
rm -f injectionprovider/src/java/com/sun/faces/vendor/GlassFishInjectionProvider.java

#  sed -i "s|com.sun.faces.vendor.Jetty6InjectionProvider:org.mortbay.jetty.plus.annotation.InjectionCollection||" injectionprovider/src/etc/com.sun.faces.spi.injectionprovider

popd

sed -i "s|@groupId@|com.sun.faces|g;" common/ant/template/jsf-api-pom-template.xml
sed -i "s|@version@|%{version}|g;" common/ant/template/jsf-api-pom-template.xml
sed -i "s|@groupId@|com.sun.faces|g;" common/ant/template/jsf-impl-pom-template.xml
sed -i "s|@version@|%{version}|g;" common/ant/template/jsf-impl-pom-template.xml

%build

pushd together
  export CLASSPATH=
  CLASSPATH=$CLASSPATH:$PWD/tools/build/tools.jar:$PWD/api/build/jsf-api.jar
  CLASSPATH=$CLASSPATH:$PWD/impl/build/jsf-impl.jar:$PWD/injectionprovider/build/injectionprovider.jar
  export OPT_JAR_LIST=:
  ant jar
  ant javadocs
popd 

# Convert to OSGi bundle  amd add poper Bundle-SymbolicName
cp -pr together/api/build/jsf-api.jar together/api/build/org.glassfish.javax.faces.jar
java -jar $(build-classpath aqute-bndlib.jar) wrap together/api/build/org.glassfish.javax.faces.jar
# TODO DynamicImport-Package: org.glassfish.flashlight.provider
cp -pr together/impl/build/jsf-impl.jar together/impl/build/org.glassfish.com.sun.faces.jar
java -jar $(build-classpath aqute-bndlib.jar) wrap together/impl/build/org.glassfish.com.sun.faces.jar

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}/
mkdir -p %{buildroot}%{_mavenpomdir}

install -pm 644 together/api/build/org.glassfish.javax.faces.bar %{buildroot}%{_javadir}/jsf-api-%{version}.jar
install -pm 644 together/impl/build/org.glassfish.com.sun.faces.bar %{buildroot}%{_javadir}/jsf-impl-%{version}.jar

install -pm 644 common/ant/template/jsf-api-pom-template.xml %{buildroot}%{_mavenpomdir}/JPP-jsf-api.pom
install -pm 644 common/ant/template/jsf-impl-pom-template.xml %{buildroot}%{_mavenpomdir}/JPP-jsf-impl.pom

%add_to_maven_depmap com.sun.faces jsf-api %{version} JPP jsf-api
%add_to_maven_depmap com.sun.faces mojarra-jsf-api %{version} JPP jsf-api
%add_to_maven_depmap javax.faces jsf-api %{version} JPP jsf-api
%add_to_maven_depmap com.sun.faces jsf-impl %{version} JPP jsf-impl
%add_to_maven_depmap com.sun.faces mojarra-jsf-impl %{version} JPP jsf-impl

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr together/api/build/javadocs/* %{buildroot}%{_javadocdir}/%{name}/
cp -pr together/impl/build/javadocs/* %{buildroot}%{_javadocdir}/%{name}/

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_javadir}/jsf-api-%{version}.jar
%{_javadir}/jsf-api.jar
%{_javadir}/jsf-impl-%{version}.jar
%{_javadir}/jsf-impl.jar
%{_mavendepmapfragdir}/*
%{_mavenpomdir}/*
%doc legal/jsf-cddl/*

%files javadoc
%{_javadocdir}/%{name}


%changelog

* Thu Oct 20 2011 gil <gil> 2.1.2-2.mga2
+ Revision: 156757
- edit depmap
- rebuilt with jetty 6.1.26-10 (injectionprovider) support

* Wed Oct 19 2011 gil <gil> 2.1.2-1.mga2
+ Revision: 156739
- edit build file
- imported package mojarra

